(function ($) {

    "use strict";

    $('form').find('a[data-submit]').on('click', function (e) {
        e.preventDefault();
        $(this).closest('form').submit();
    });

    $('form[data-confirm]').on('submit', function (e) {
        if (!confirm('Are you sure?')) {
            e.preventDefault();
        }
    });

    /*
     * Dynamically toggle field visibility
     */
    var form = $('form#ewcc_registration');

    var accommodationField = form.find('#reg_official_accommodation');
    var transferField = form.find('#reg_transfer');
    var timeFields = form.find('#reg_arrival_at_field,#reg_departure_at_field');

    function updateArrivalDepartureFields() {
        if (accommodationField.val() == 'yes' || transferField.val() == 'yes') {
            timeFields.find('input,select').attr('disabled', false).trigger('change');
            timeFields.show();
        } else {
            timeFields.hide();
            timeFields.find('input,select').attr('disabled', true).trigger('change');
        }
    }

    if (form.length > 0) {
        form.parsley();

        /*
        Form field visibility
         */
        form.find('[data-target-field]').each(function (i, el) {
            var targetField = $($(el).attr('data-target-field'));
            var matchTargetElValue = $(el).attr('data-target-value');

            if (targetField.length > 0) {
                targetField.on('change', function (e) {
                    if (!$(this).attr('disabled') && $(this).val() == matchTargetElValue) {
                        $(el).find('input,select').attr('disabled', false).trigger('change');
                        $(el).show();
                    } else {
                        $(el).hide();
                        $(el).find('input,select').attr('disabled', true).trigger('change');

                    }
                });
                targetField.trigger('change');
            }
        });

        accommodationField.on('change', updateArrivalDepartureFields);
        transferField.on('change', updateArrivalDepartureFields);

        /*
        Form field validation
         */
        form.find('#reg_type').on('change', function (e) {
            form.find('#reg_fide_id,#reg_fide_rating,#reg_fide_title,#reg_federation').attr('data-parsley-required', $(this).val() == 'player');
            form.parsley().reset();
        });
        form.find('#reg_type').trigger('change');

        form.find('#reg_invitation_required').on('change', function (e) {
            form.find('#invitation-fields').find('input').attr('data-parsley-required', $(this).val() == 'yes');
            form.parsley().reset();
        });
        form.find('#reg_invitation_required').trigger('change');

        accommodationField.on('change', function (e) {
            form.find('#reg_arrival_at,#reg_departure_at').attr('data-parsley-required', $(this).val() == 'yes' || transferField.val() == 'yes');
            form.find('#reg_room_type').attr('data-parsley-required', $(this).val() == 'yes');
            form.parsley().reset();
        });

        transferField.on('change', function (e) {
            form.find('#reg_arrival_at,#reg_departure_at').attr('data-parsley-required', $(this).val() == 'yes' || accommodationField.val() == 'yes');
            form.find('#reg_arrival_flight_number,#reg_departure_flight_number').attr('data-parsley-required', $(this).val() == 'yes');
            form.parsley().reset();
        });

        accommodationField.trigger('change');
        transferField.trigger('change');
    }


    $('.datetimepicker').datetimepicker({ format: 'Y-m-d H:i' });

    $('.datepicker').datetimepicker({ timepicker: false, format: 'Y-m-d' });


})(jQuery);